unit trava_unit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, IdCookieManager, IdBaseComponent, IdComponent, IdTCPConnection,
  IdTCPClient, IdHTTP, StdCtrls, IdCookie, IdMultipartFormData,
  IdIntercept, IdLogBase, IdLogStream,wininet, Grids, ComCtrls, ExtCtrls,
  IdIOHandler, IdIOHandlerSocket, res_trava, IdCompressionIntercept,
  func_trava;

type
  TForm1 = class(TForm)
    IdHTTP1: TIdHTTP;
    IdCookieManager1: TIdCookieManager;
    Start: TButton;
    Memo1: TMemo;
    Label1: TLabel;
    ProxyAdress: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    ProxyPort: TEdit;
    Label4: TLabel;
    ProxyUser: TEdit;
    Label5: TLabel;
    ProxyPassword: TEdit;
    ProxyUse: TCheckBox;
    ServerName: TEdit;
    Label6: TLabel;
    Village: TPageControl;
    Ferms: TTabSheet;
    CenterVillage: TTabSheet;
    StringGrid1: TStringGrid;
    LabelUserName: TLabel;
    UserName: TEdit;
    Label7: TLabel;
    UserPassword: TEdit;
    StringGrid2: TStringGrid;
    StringGrid3: TStringGrid;
    BuildTimer: TTimer;
    OrderConstruction: TEdit;
    StartBuild: TButton;
    ResTimer: TTimer;
    CurTime: TLabel;
    StringGrid4: TStringGrid;
    StopBuild: TButton;
    OrderConstLabel: TLabel;
    SaveControl: TButton;
    Label10: TLabel;
    CloseToTray: TButton;
    Label11: TLabel;
    FarmTimer: TTimer;
    AddAuto: TButton;
    All_Village: TPageControl;
    NameVillage: TTabSheet;
    ProportionLabel: TLabel;
    Proportional: TEdit;
    MiscPages: TPageControl;
    Option: TTabSheet;
    TaskList: TTabSheet;
    StringGrid5: TStringGrid;
    Refresh: TButton;
    AutoProportion: TCheckBox;
    UserInfoLabel: TLabel;
    Button3: TButton;
    Farm: TTabSheet;
    VillageArmy: TStringGrid;
    GetArmyB: TButton;
    FarmTask: TStringGrid;
    AddFarmTask: TButton;
    SendArmy: TButton;
    DelFarmTask: TButton;
    SaveFarmTask: TButton;
    VillageArmyLabel: TLabel;
    FarmTaskLabel: TLabel;
    FarmPodkrep: TCheckBox;
    FarmNapadenie: TCheckBox;
    FarmNabeg: TCheckBox;
    LoadFarmTask: TButton;
    SendCom: TCheckBox;
    SendParal: TCheckBox;
    FarmListTask: TTabSheet;
    StringGrid6: TStringGrid;
    StopFarm: TButton;
    BonusRim: TCheckBox;
    procedure IdCookieManager1NewCookie(ASender: TObject;
      ACookie: TIdCookieRFC2109; var VAccept: Boolean);
    procedure StartClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure StringGrid1DblClick(Sender: TObject);
    procedure StringGrid2DblClick(Sender: TObject);
    procedure ResTimerTimer(Sender: TObject);
    procedure StopBuildClick(Sender: TObject);
    procedure SaveControlClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure CloseToTrayClick(Sender: TObject);
    procedure AddAutoClick(Sender: TObject);
    procedure StartBuildClick(Sender: TObject);
    procedure HandWorkClick(Sender: TObject);
    procedure AutoWorkProportionalClick(Sender: TObject);
    procedure BuildTimerTimer(Sender: TObject);
    procedure RefreshClick(Sender: TObject);
    procedure AutoProportionClick(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure GetArmyBClick(Sender: TObject);
    procedure FarmNabegClick(Sender: TObject);
    procedure FarmNapadenieClick(Sender: TObject);
    procedure FarmPodkrepClick(Sender: TObject);
    procedure AddFarmTaskClick(Sender: TObject);
    procedure VillageArmyDblClick(Sender: TObject);
    procedure DelFarmTaskClick(Sender: TObject);
    procedure SendComClick(Sender: TObject);
    procedure SendParalClick(Sender: TObject);
    procedure SendArmyClick(Sender: TObject);
    procedure FarmTimerTimer(Sender: TObject);
    procedure StopFarmClick(Sender: TObject);
    procedure SaveFarmTaskClick(Sender: TObject);
    procedure LoadFarmTaskClick(Sender: TObject);










  private
    { Private declarations }

  public
    { Public declarations }
     procedure IconCallBackMessage( var Mess : TMessage );
     message WM_USER+ 100;

  end;



  type army=record
  id:integer;
  num:integer;
  name:string;
  snd:string;
  end;

  type town=record
  id:integer;
  name:string;
  res_req:array[0..3] of integer;
  res_need:array[0..3] of integer;
  res_time:TDatetime;
  lvl:integer;
  tip:integer;// , build.php?gid=
  end;

  type resource=record
  per_hour:integer;
  v_nalichee:integer;
  sklad:integer;
  for_timer:integer;
  end;

  type Village=record
  vil_name:string;
  vil_href:string;
  vil_bilding:array[0..40]of town;
  res_village:array[0..3]of resource;
  vil_army:array[0..10] of army;
  end;

  type TVillage=array of Village; //

  type TBuildTask=record
  time:Tdatetime;
  tip:integer;//-1=,0= , 1=
  status:String;
  end;

  type TFarmTask=record
  vid:integer;//id 
  time:TdateTime;//
  tip:integer;//0 - , 1-
  stat:integer;//-1=,0=, 1-   2-  
  line:integer;//    FarmTask
  col:integer;// 
  name:string;
  end;

var
  Form1: TForm1;
  ItemVilage:array of TTabSheet;// 
  PCVillage:array of TPageControl;//   
  Items:array of TTabSheet;//  
  ListVill:array of TStringGrid;//
  Edits:array of TEdit;//
  Labels:array of TLabel;//
  Buttons:array of TButton;//
  CheckBoxs:array of TCheckbox;
  CheckBoxsCol,ItemsCol,ListVillCol,EditsCol,LabelsCol,ButtonsCol:Integer;//-  



  MaxV:integer;
  vil_task:array of TBuildTask;
  vil_farm:array of TFarmTask;
  FTC:integer;//    
  user_info:Tuser_info;
  Response,server,path_profile,path_dorf1,path_dorf2,path_build,path_login,path_send_troop:String;
  tray_tip:string;
  akk:TVillage;
  vil_id:integer;//id  
  last_update_res:Tdatetime;//      
  last_build_id:integer;//  
  building_now:boolean;//     
  res_req:array[0..3] of integer =(0,0,0,0);
  res_need:array[0..3] of integer =(0,0,0,0);
  buildingCost:Res_all;
  Chudo:res_chudo;

  // 

  implementation
{$R *.dfm}


uses ShellAPI;

procedure show_user_info;
begin
form1.UserInfoLabel.Caption:=user_info.name+#13+
                             ': '+IntTostr(user_info.rang)+#13+
                             ': '+user_info.rase+#13+
                             ': '+user_info.ally+#13+
                             '- : '+IntTostr(user_info.max_vil)+#13+
                             ': '+IntTostr(user_info.naselenie);

end;

procedure log(s:string);
begin
form1.Memo1.Lines.Add(DateTimeToStr(now)+' >>> '+s);
end;


procedure get_list_vil(resp:string;Max_V:integer);
var i:integer;
begin
if pos('href="dorf3.php"',resp)<>0 then
  begin
  delete(resp,1,pos('href="dorf3.php"',resp)-1);
  for i:=0 to Max_V-1 do begin
  akk[i].vil_href:=get_href('?newdid=','"',resp);
  delete(resp,1,pos('?newdid=',resp)-1);
  akk[i].vil_name:=get_param2('>','<',resp);
  end;//for i
  end;//if
end;


procedure calc_res_need(vid:integer;res:array of integer;var need:array of integer;var time_need:TdateTime);
var buf:integer;buf2,buf3:tdate;

begin
 time_need:=0;
   //
   buf:=res[0]-akk[vid].res_village[0].v_nalichee; if buf<0 then buf:=0;
   need[0]:=buf;
   buf2:=buf/akk[vid].res_village[0].per_hour; buf3:=buf2;
   //
   buf:=res[1]-akk[vid].res_village[1].v_nalichee; if buf<0 then buf:=0;
   need[1]:=buf;
   buf2:=buf/akk[vid].res_village[1].per_hour;
   if buf2>buf3 then buf3:=buf2;
   //
   buf:=res[2]-akk[vid].res_village[2].v_nalichee; if buf<0 then buf:=0;
   need[2]:=buf;
   buf2:=buf/akk[vid].res_village[2].per_hour;
   if buf2>buf3 then buf3:=buf2;
   //
   buf:=res[3]-akk[vid].res_village[3].v_nalichee; if buf<0 then buf:=0;
   need[3]:=buf;
   buf2:=buf/akk[vid].res_village[3].per_hour;
   if buf2>buf3 then buf3:=buf2;
   //
   buf3:=buf3/24;
   time_need:=buf3;
end;

//    - id = 
procedure get_res_need_b(id:integer;response:string;var res:array of integer);
var qw:string;
begin
qw:='<table class="f10"><tr><td><img class="res" src="';
delete(response,1,pos(qw,response));
if (akk[vil_id].vil_bilding[id].tip=0) and (id<>0) then
                              begin //   
                                res[0]:=0;res[1]:=0;res[2]:=0;res[3]:=0;
                                exit;
                              end;

res[0]:=bild_lvl(get_param2('img/un/r/1.gif">','|',Response));
res[1]:=bild_lvl(get_param2('img/un/r/2.gif">','|',Response));
res[2]:=bild_lvl(get_param2('img/un/r/3.gif">','|',Response));
res[3]:=bild_lvl(get_param2('img/un/r/4.gif">','|',Response));
if res[0]=0 then res[0]:=-1;
if res[1]=0 then res[0]:=-1;
if res[2]=0 then res[0]:=-1;
if res[3]=0 then res[0]:=-1;
end;


procedure get_res_by_id(vid:integer;i:integer;Response:string;var req,need:array of integer;var time:TDatetime);
begin
  get_res_need_b(i,Response,req);
  calc_res_need(vid,req,need,time);
end;




procedure TForm1.IconCallBackMessage( var Mess : TMessage );
var
 sEventLog : String;
begin
case Mess.lParam of
//      . ,        .
WM_LBUTTONDBLCLK  : sEventLog := '   ';
WM_LBUTTONDOWN    :  //sEventLog := '   ';
begin
Application.CreateHandle;
ShowWindow(Application.Handle, SW_SHOW);
Application.ShowMainForm := TRUE;
Application.Restore;
end;
WM_LBUTTONUP      :  sEventLog := '   ';
WM_MBUTTONDBLCLK  :  sEventLog := '  ';
WM_MBUTTONDOWN    :  sEventLog := '  ';
WM_MBUTTONUP      :  sEventLog := '  ';
WM_MOUSEMOVE      :  sEventLog := ' ';
WM_MOUSEWHEEL     :  sEventLog := '  ';
WM_RBUTTONDBLCLK  :  sEventLog := '   ';
WM_RBUTTONDOWN    :  //sEventLog := '   ';
begin
Application.Minimize;
Application.CreateHandle;
ShowWindow(Application.Handle, SW_HIDE);
Application.ShowMainForm := FALSE;

end;

WM_RBUTTONUP      :  sEventLog := '   ';
end;
end;


 procedure Delay(delay: DWORD); //   
 var
   lTicks: DWORD;
 begin
   lTicks := GetTickCount + delay;
   repeat
     Sleep(100);
     Application.ProcessMessages;
   until (lTicks <= GetTickCount) or Application.Terminated;
 end;

procedure TForm1.IdCookieManager1NewCookie(ASender: TObject; //. 
  ACookie: TIdCookieRFC2109; var VAccept: Boolean);
begin
 VAccept := true;
 if ACookie.Path='' then ACookie.Path:='/';
end;

Procedure try_get_page(addr, refer:string; var response:string; var f:boolean);
begin
form1.IdHTTP1.Request.Referer:=refer; f:=false;
 Response:='';
 try
 Response:=form1.IdHTTP1.Get(addr);
 except
  on E: Exception do
  begin
  log(E.Message);
  exit;
  end;
 end;
 f:=true;
 Response:=UTF8toAnsi(response);
 form1.idHTTP1.Disconnect;
end;

Procedure try_post_page(addr, refer:string;data:TStringlist; var response:string; var f:boolean);
begin
form1.IdHTTP1.Request.Referer:=refer; f:=false;
 Response:='';
 try
 Response:=form1.IdHTTP1.Post(addr,data);
 except
  on E: Exception do
  begin
  log(E.Message);
  exit;
  end;
 end;
 f:=true;
 Response:=UTF8toAnsi(response);
 form1.idHTTP1.Disconnect;
end;

Procedure Login_Trava(var f:boolean);
var
login,name,pass,pass2:string;
ff:boolean;
//data:TIdMultiPartFormDataStream;
data:TStringList;
begin
//data:=TIdMultiPartFormDataStream.Create;
data:=TstringList.Create;
response:='';
if form1.ProxyUse.Checked then
   begin
   form1.IdHTTP1.ProxyParams.ProxyServer:=form1.ProxyAdress.Text;
   form1.Idhttp1.ProxyParams.ProxyPort:=StrToInt(form1.ProxyPort.Text);
   form1.Idhttp1.ProxyParams.ProxyUsername:=form1.ProxyUser.Text;
   form1.Idhttp1.ProxyParams.ProxyPassword:=form1.ProxyPassword.Text;
   form1.Idhttp1.ProxyParams.BasicAuthentication:=true;
   end
   else
     begin
   form1.IdHTTP1.ProxyParams.ProxyServer:='';
   form1.Idhttp1.ProxyParams.ProxyPort:=0;
   form1.Idhttp1.ProxyParams.ProxyUsername:='';
   form1.Idhttp1.ProxyParams.ProxyPassword:='';
   form1.Idhttp1.ProxyParams.BasicAuthentication:=false;
     end;
form1.idhttp1.Host:=form1.ServerName.Text;
form1.idhttp1.Request.Host:=form1.ServerName.Text;
form1.idhttp1.Request.AcceptLanguage:='ru';
form1.idhttp1.Request.UserAgent:='Mozilla/4.0 (compatible; MSIE 7.0; Windows NT 5.1; Avant Browser';
form1.idhttp1.Request.ProxyConnection:='Keep-Alive';
form1.idhttp1.Request.Connection:='Keep-Alive';
form1.IdHTTP1.HandleRedirects := True;
form1.IdHTTP1.Request.Referer:='http://www.google.ru';

//   
  ff:=false;
  try_get_page(path_login,'http://www.google.ru',Response,ff);

  if ff then
  begin // 
  login:=get_login_param('name="login" value="','">',response);
  name:=get_login_param('<input class="fm fm110" type="text" name="','" ',response);
  pass:=get_login_param('<input class="fm fm110" type="password" name="','" ',response);
  pass2:=get_login_param('<input type="hidden" name="','" ',response);
  //data.AddFormField('w','1280:1024');
  //data.AddFormField('login',login);
  //data.AddFormField(name,UrlEncode(form1.UserName.Text,true));
  //data.AddFormField(pass,UrlEncode(form1.UserPassword.Text,true));
  //data.AddFormField(pass2,'');
  //data.AddFormField('autologin','ja');
    data.Add('w=1280:1024');
    data.Add('login='+login);
    data.Add(name+'='+AnsiToUTF8(form1.UserName.Text));
    data.Add(pass+'='+AnsiToUTF8(form1.UserPassword.Text));
    data.Add(pass2+'=');
    data.Add('autologin=ja');
    data.Add('s1.x=0');
    data.Add('s1.y=0');
  form1.IdHTTP1.Request.Referer:=path_login;
  //
   try
    Response:=form1.IdHTTP1.Post(path_dorf1,data);
   except
   on E: Exception do
   begin
   log(E.Message);
   exit;
   end;
   end;
  Response:=UTF8toAnsi(response);
  //
  login:=get_login_param('name="login" value="','">',response);
  if login='' then f:=true else f:=false;
  end;//if f then
  Data.Free;
  form1.idHTTP1.Disconnect;

end;//Procedure Login_Trava;

function village_name(resp:string):string;//  
begin
village_name:=get_param('<div class="dname"><h1>','</h1></div>',resp);
end;//village_name

//   (id=1..18)
procedure get_ferm(vid:integer;resp:string;var ferm:array of town);
var i,j,field_tip:integer; s1:string;
//f:boolean;
id_z:integer;
begin
s1:='<map name="rx">';
i:=pos(s1,resp);
delete(resp,1,i+length(s1)-1);
//   id 
for i:=1 to 18 do begin
Application.ProcessMessages;
id_z:=bild_lvl(get_param2('href="build.php?id=','"',resp));
ferm[id_z].id:=id_z;
ferm[id_z].name:=get_param2('title="','">',resp);
ferm[id_z].lvl:=bild_lvl(ferm[id_z].name);
end;

s1:=get_param2('<div id="f','">',resp);
if s1='' then begin log('   '); exit end;
field_tip:=bild_lvl(s1);//     

for i:=1 to 18 do begin
  Application.ProcessMessages;
  ferm[i].tip:=fields_type[field_tip,i];
  //   ferm[id_z].lvl+1 -     
     for j:=0 to 3 do
       begin
       ferm[i].res_req[j]:=BuildingCost[ferm[i].tip,ferm[i].lvl+1,j];
       end;//for j
       calc_res_need(vid,ferm[i].res_req,ferm[i].res_need,ferm[i].res_time);
end;//for i

end;//get_ferm

procedure show_ferm;
var i,j:integer;
begin

for j:=0 to MaxV-1 do begin

for i:=1 to 18 do begin
ListVill[ListVillCol*j].Cells[0,i]:=IntToStr(akk[j].vil_bilding[i].id);
ListVill[ListVillCol*j].Cells[1,i]:=akk[j].vil_bilding[i].name;
case akk[j].vil_bilding[i].res_req[0] of
0: begin
    ListVill[ListVillCol*j].Cells[2,i]:='';
    ListVill[ListVillCol*j].Cells[3,i]:='';
    ListVill[ListVillCol*j].Cells[4,i]:='';
   end;
-1: begin
    ListVill[ListVillCol*j].Cells[2,i]:=' ';
    ListVill[ListVillCol*j].Cells[3,i]:='';
    ListVill[ListVillCol*j].Cells[4,i]:='';
    end;
-2: begin
    ListVill[ListVillCol*j].Cells[2,i]:=' ';
    ListVill[ListVillCol*j].Cells[3,i]:='';
    ListVill[ListVillCol*j].Cells[4,i]:='';
    end;
else begin
    ListVill[ListVillCol*j].Cells[2,i]:= Str_res(akk[j].vil_bilding[i].res_req);
    ListVill[ListVillCol*j].Cells[3,i]:= Str_res(akk[j].vil_bilding[i].res_need);
    ListVill[ListVillCol*j].Cells[4,i]:=TimeToStr(akk[j].vil_bilding[i].res_time);
     end;
end;//case
end;//for i
ListVill[ListVillCol*j].RowCount:=19;

for i:=19 to 40 do begin
ListVill[ListVillCol*j+1].Cells[0,i-18]:=IntToStr(akk[j].vil_bilding[i].id);
ListVill[ListVillCol*j+1].Cells[1,i-18]:=akk[j].vil_bilding[i].name;
case akk[j].vil_bilding[i].res_req[0] of
0: begin
    ListVill[ListVillCol*j+1].Cells[2,i-18]:=' ';
    ListVill[ListVillCol*j+1].Cells[3,i-18]:='';
    ListVill[ListVillCol*j+1].Cells[4,i-18]:='';
   end;
-1: begin
    ListVill[ListVillCol*j+1].Cells[2,i-18]:=' ';
    ListVill[ListVillCol*j+1].Cells[3,i-18]:='';
    ListVill[ListVillCol*j+1].Cells[4,i-18]:='';
    end;
-2: begin
    ListVill[ListVillCol*j+1].Cells[2,i-18]:=' ';
    ListVill[ListVillCol*j+1].Cells[3,i-18]:='';
    ListVill[ListVillCol*j+1].Cells[4,i-18]:='';
    end;
else begin
    ListVill[ListVillCol*j+1].Cells[2,i-18]:= Str_res(akk[j].vil_bilding[i].res_req);
    ListVill[ListVillCol*j+1].Cells[3,i-18]:= Str_res(akk[j].vil_bilding[i].res_need);
    ListVill[ListVillCol*j+1].Cells[4,i-18]:=TimeToStr(akk[j].vil_bilding[i].res_time);
     end;
end;//case
end;//for i
ListVill[ListVillCol*j+1].RowCount:=23;
ListVill[ListVillCol*j].Refresh;
ListVill[ListVillCol*j+1].Refresh;
end;//for j
end;

procedure get_center(vid:integer;resp:string;var ferm:array of town);
type ferm_temp=record
     name:string;
     tip:integer;
     end;
var i,j:integer; s1:string;
id_z:integer; field_tip:integer;
ferm2:array[19..40] of ferm_temp;
ff:boolean;
begin
s1:='class="dname"';
i:=pos(s1,resp);
delete(resp,1,i+length(s1)-1);

//  
for i:=19 to 38 do begin
Application.ProcessMessages;
s1:=get_param2('img/un/g/','.gif',resp);
if pos('b',s1)<>0 then ferm2[i].name:='>>> ' else ferm2[i].name:='';
field_tip:=bild_lvl(s1);
if s1='iso' then begin
                 ferm2[i].tip:=0;
                 end
             else
                  begin
                  case field_tip of
                  40,401,402,403,404,405:field_tip:=40;
                  end;//case
                  ferm2[i].tip:=field_tip;
                  end;
end;//for i
ferm2[39].tip:=16;
s1:=get_param2('class="d2_x d2_','">',resp);
if s1='0' then ferm2[40].tip:=0;// ;
if s1='11' then ferm2[40].tip:=31;// 
if s1='12' then ferm2[40].tip:=32;// 
if s1='1' then ferm2[40].tip:=33;// 

s1:='<map name="map1">';
i:=pos(s1,resp);
delete(resp,1,i+length(s1)-1);
// , ,  
for i:=19 to 40 do begin
Application.ProcessMessages;
id_z:=StrToInt(get_param2('href="build.php?id=','" ',resp));
ferm[id_z].id:=id_z;
ferm[i].tip:=ferm2[i].tip;
ferm[id_z].name:=ferm2[i].name+get_param2('title="','"',resp);
ferm[id_z].lvl:=bild_lvl(ferm[id_z].name);
end;
//  
for i:=19 to 40 do begin
Application.ProcessMessages;
  //   ferm[id_z].lvl+1 -     
     for j:=0 to 3 do
       begin
       if ferm[i].tip<>40 then ferm[i].res_req[j]:=BuildingCost[ferm[i].tip,ferm[i].lvl+1,j]
                          else ferm[i].res_req[j]:=chudo[ferm[i].lvl+1,j];//   )))
       end;//for j
       calc_res_need(vid,ferm[i].res_req,ferm[i].res_need,ferm[i].res_time);
end;//for i

if ferm[40].tip=0 then
                   begin
                   try_get_page(path_build+'40',path_dorf2,s1,ff);
                   get_res_by_id(vid,40,s1,ferm[40].res_req,ferm[40].res_need,ferm[40].res_time);
                   //ferm[40].tip=0;
                   end;
end;//get_ferm

procedure show_res;
var i,j:integer;
begin
for j:=0 to MaxV-1 do begin
for i:=0 to 3 do begin
ListVill[ListVillCol*j+2].Cells[1,i+1]:=IntToStr(akk[j].res_village[i].per_hour);
ListVill[ListVillCol*j+2].Cells[2,i+1]:=IntToStr(akk[j].res_village[i].v_nalichee);
ListVill[ListVillCol*j+2].Cells[3,i+1]:=IntToStr(akk[j].res_village[i].sklad);
end;//for i
ListVill[ListVillCol*j+2].RowCount:=5;
ListVill[ListVillCol*j+2].Refresh;
end;//for j
end;


procedure get_res(resp:string;var pr:array of resource);
var s1:string;
begin
if pos('id="lres0"',Response)<>0 then
   begin
  delete(Resp,1,pos('id="lres0"',Resp)-1);
  //
  s1:=get_param2('id=l4 title=','>',resp);
  pr[0].per_hour:=bild_lvl(s1);
  s1:=get_param2('>','/',resp);
  pr[0].v_nalichee:=bild_lvl(s1);
  pr[0].for_timer:=pr[0].v_nalichee;
  s1:=get_param2('/','<',resp);
  pr[0].sklad:=bild_lvl(s1);
  pr[1].sklad:=pr[0].sklad;
  pr[2].sklad:=pr[0].sklad;
  //
  s1:=get_param2('id=l3 title=','>',resp);
  pr[1].per_hour:=bild_lvl(s1);
  s1:=get_param2('>','/',resp);
  pr[1].v_nalichee:=bild_lvl(s1);
  pr[1].for_timer:=pr[1].v_nalichee;
  //
  s1:=get_param2('id=l2 title=','>',resp);
  pr[2].per_hour:=bild_lvl(s1);
  s1:=get_param2('>','/',resp);
  pr[2].v_nalichee:=bild_lvl(s1);
  pr[2].for_timer:=pr[2].v_nalichee;
  //
  s1:=get_param2('id=l1 title=','>',resp);
  pr[3].per_hour:=bild_lvl(s1);
  s1:=get_param2('>','/',resp);
  pr[3].v_nalichee:=bild_lvl(s1);
  pr[3].for_timer:=pr[3].v_nalichee;
  s1:=get_param2('/','<',resp);
  pr[3].sklad:=bild_lvl(s1);
  last_update_res:=now;
  show_res;
end;
//else log('    .');

end;

procedure res_convert(res:string;var res_c:array of integer;var f:boolean);
var s1:string;
begin
f:=true;
s1:=copy(res,1,pos('-',res)-1); delete(res,1,pos('-',res));
if tryStrToInt(s1,res_c[0]) then res_c[0]:=strtoInt(s1) else f:=false;
s1:=copy(res,1,pos('-',res)-1); delete(res,1,pos('-',res));
if tryStrToInt(s1,res_c[1]) then res_c[1]:=strtoInt(s1) else f:=false;
s1:=copy(res,1,pos('-',res)-1); delete(res,1,pos('-',res));
if tryStrToInt(s1,res_c[2]) then res_c[2]:=strtoInt(s1) else f:=false;
s1:=res;
if tryStrToInt(s1,res_c[3]) then res_c[3]:=strtoInt(s1) else f:=false;
end;




procedure get_list_new_bild(vid:integer;Response:string);//  
var name:string;id:integer;req,need:array[0..3]of integer;
time:TdateTime;
begin
id:=0;
repeat
inc(id);
name:=get_param2('<h2>','</h2>',Response);
get_res_need_b(id,Response,req);
calc_res_need(vid,req,need,time);
ListVill[ListVillCol*vid+3].Cells[0,id]:=IntToStr(id);
ListVill[ListVillCol*vid+3].Cells[1,id]:=name;
ListVill[ListVillCol*vid+3].Cells[2,id]:=str_res(req);
ListVill[ListVillCol*vid+3].Cells[3,id]:=str_res(need);
ListVill[ListVillCol*vid+3].Cells[4,id]:=TimeToStr(time);
until get_param('<h2>','</h2>',Response)='';
ListVill[ListVillCol*vid+3].RowCount:=id+1;
ListVill[ListVillCol*vid+3].Refresh;
end;

procedure create_village(max_v:integer);
var i,j:integer;
begin
 for i:=1 to maxv-1 do begin
 //   
 ItemVilage[i]:=TTabSheet.Create(Form1);
 ItemVilage[i].PageControl:=form1.All_Village;
 //pagecontrol   
 PCVillage[i]:=TPageControl.Create(Form1);
 PCVillage[i].Parent:=ItemVilage[i];
 CopyPageControl(PCVillage[0],PCVillage[i]);
 //   
 for j:=0 to ItemsCol-1 do begin
 Items[ItemsCol*i+j]:=TTabSheet.Create(Form1);
 Items[ItemsCol*i+j].PageControl:=PCVillage[i];
 CopyTabSheet(Items[j],Items[ItemsCol*i+j]);
 end;
 //stringgrid
 for j:=0 to ListVillCol-1 do begin
 ListVill[ListVillCol*i+j]:=TStringGrid.Create(Form1);
 CopyStringGrid(ListVill[j],ListVill[ListVillCol*i+j]);
 case j of
 0,2:ListVill[ListVillCol*i+j].Parent:=Items[ItemsCol*i];
 1,3:ListVill[ListVillCol*i+j].Parent:=Items[ItemsCol*i+1];
 4,5:ListVill[ListVillCol*i+j].Parent:=Items[ItemsCol*i+2];
 end;//case
 end;
 //edit  
 for j:=0 to EditsCol-1 do begin
 Edits[EditsCol*i+j]:=TEdit.Create(Form1);
 CopyEdit(Edits[j],Edits[EditsCol*i+j]);
 case j of
 0:Edits[EditsCol*i+j].Parent:=ItemVilage[i];
 1:Edits[EditsCol*i+j].Parent:=Items[ItemsCol*i];
 end;//case
 end;
//
 for j:=0 to LabelsCol-1 do begin
 Labels[LabelsCol*i+j]:=TLabel.Create(Form1);
 CopyLabel(Labels[j],Labels[LabelsCol*i+j]);
 case j of
 0:Labels[LabelsCol*i+j].Parent:=ItemVilage[i];
 1:Labels[LabelsCol*i+j].Parent:=Items[ItemsCol*i];
 2,3:Labels[LabelsCol*i+j].Parent:=Items[ItemsCol*i+2];
 end;//case
 end;
//
 for j:=0 to ButtonsCol-1 do begin
 Buttons[ButtonsCol*i+j]:=TButton.Create(Form1);
 CopyButton(Buttons[j],Buttons[ButtonsCol*i+j]);
 case j of
 0..3:Buttons[ButtonsCol*i+j].Parent:=ItemVilage[i];
 4..10:Buttons[ButtonsCol*i+j].Parent:=Items[ItemsCol*i+2];
 end;//case
 end;
 //
 for j:=0 to CheckBoxsCol-1 do begin
 CheckBoxs[CheckBoxsCol*i+j]:=TCheckBox.Create(Form1);
 CopyCheckBoxs(CheckBoxs[j],CheckBoxs[CheckBoxsCol*i+j]);
 case j of
 0:CheckBoxs[CheckBoxsCol*i+j].Parent:=Items[ItemsCol*i];
 1..5:CheckBoxs[CheckBoxsCol*i+j].Parent:=Items[ItemsCol*i+2];
 end;//case
 end;
end;//for i

end;//create_village

procedure switch_village(i:integer;refer:string);
var ff:boolean;
begin
try_get_page(path_dorf1+akk[i].vil_href,refer,response,ff);
if ff=false then exit;
 if pos('name="login" value="',response)<>0 then
  begin
  log('  , ...');
  Login_trava(ff);
   if ff=false then begin
                    log('  !!!');
                    exit;
                    end;
  try_get_page(path_dorf1+akk[i].vil_href,refer,response,ff);
  end;

vil_id:=i;
end;

procedure save_option;
var i:integer;
ft:textfile;
begin
assignfile(ft,'option.ini');
{$I-}
Rewrite(ft);
{$I+}
if ioresult<>0 then begin
                    //log('  ,   ');
                    exit;
                    end;

for i:=0 to MaxV-1 do begin
writeln(ft,akk[i].vil_name,'>',Edits[EditsCol*i].Text);
writeln(ft,akk[i].vil_name,'>',Edits[EditsCol*i+1].Text);
end;//fori
closefile(ft);
end;

procedure load_option;
var i,j:integer;
ft:textfile; s1,s2:string;
begin
assignfile(ft,'option.ini');
{$I-}
reset(ft);
{$I+}
if ioresult<>0 then begin
                    //log('  ,   ');
                    exit;
                    end;

For i:=0 to MAxV-1 do begin
readln(ft,s1);
s2:=copy(s1,1,pos('>',s1)-1);//id
  for j:=0 to MaxV-1 do
    begin
    if akk[j].vil_name=s2 then Edits[EditsCol*j].Text:=copy(s1,pos('>',s1)+1,length(s1)-pos('>',s1));
    end;
readln(ft,s1);
s2:=copy(s1,1,pos('>',s1)-1);//id
  for j:=0 to MaxV-1 do
    begin
    if akk[j].vil_name=s2 then Edits[EditsCol*j+1].Text:=copy(s1,pos('>',s1)+1,length(s1)-pos('>',s1));
    end;
end;//for i
closefile(ft);
end;//load_option
procedure show_army(vid:integer);
var i:integer;
begin
for i:=0 to 10 do begin
ListVill[ListVillCol*vid+4].Cells[0,i+1]:=akk[vid].vil_army[i].name+' (t'+IntToStr(i+1)+')';
ListVill[ListVillCol*vid+4].Cells[1,i+1]:=IntToStr(akk[vid].vil_army[i].num);
end;//for i
end;//procedure show_army;

procedure get_army(resp:string;var army_v:array of army);
var i,j,k,l:integer; ff:boolean;
buf:army;
s1:string;
begin
i:=0; ff:=false;
repeat
s1:=get_param2('<img class="unit"','>',resp);
if s1<>'' then begin
               army_v[i].id:=bild_lvl(get_param('img/un/u/','.gif',s1));
               army_v[i].name:=get_param('title="','"',s1)
               end
               else ff:=true;
if ff=false then
     begin
               s1:=get_param2('<input class="fm"','>',resp);
               if s1<>'' then begin
                              army_v[i].snd:=get_param('name="','"',s1);
                              end;
               j:=pos('<img class="unit"',resp);
               k:=pos('<a href="#"',resp);
                if (j>k) or((j=0) and (k<>0)) then begin
                             s1:=get_param2('<a href="#"','</a>',resp);
                             army_v[i].num:=bild_lvl(get_param2('value=',';',s1));
                            end
                            else army_v[i].num:=0;
     inc(i);
     end;
until  ff;
//
if i=11 then begin
             army_v[10].name:='';
             army_v[10].id:=99;
             end
        else begin
             army_v[10].name:='';
             army_v[10].num:=0;
             army_v[10].snd:='';
             army_v[10].id:=0;
             end;
//  id  // 
for i:=0 to 8 do begin
k:=army_v[i].id; l:=i;
for j:=i+1 to 9 do begin
if k>army_V[j].id then begin k:=army_V[j].id; l:=j end;
end;//for j
buf:=army_V[i];
army_V[i]:=army_V[l];
army_V[l]:=buf;
end;//for i

end;//get_army
// 
procedure TForm1.StartClick(Sender: TObject);
var f:boolean;
i:integer;
s1:string;
begin
Randomize;
Server:='http://'+form1.ServerName.Text+'/';
path_dorf1:=server+'dorf1.php';
path_dorf2:=server+'dorf2.php';
path_build:=server+'build.php?id=';
path_login:=server+'login.php';
path_send_troop:=server+'a2b.php';
Login_Trava(f);
if f then log(' ')
     else
     begin
     log('   (((');
     exit;
     end;

//  
try_get_page(path_dorf1,path_login,Response,f);
if f=false then begin log('  dorf1.php');exit end;
vil_id:=0;
//   
path_profile:=get_href('spieler.php?uid=','">',Response);
path_profile:=server+path_profile;
try_get_page(path_profile,path_dorf1,s1,f);
get_user_info(s1,user_info);show_user_info;
MaxV:=user_info.max_vil;
SetLength(akk,MaxV);//     - 
get_list_vil(Response,MaxV);//  
FTC:=0;
//- 
ItemsCol:=3;//  
ListVillCol:=6;//- 
EditsCol:=2;//- edit
LabelsCol:=4;//- 
ButtonsCol:=11;//- 
CheckBoxsCol:=6;//chekbox'
//  
SetLength(vil_farm,FTC);
SetLength(Vil_Task,MaxV);
//  
SetLength(ItemVilage,MaxV);
SetLength(PCVillage,MaxV);
SetLength(Items,ItemsCol*MaxV);
SetLength(ListVill,ListVillCol*MaxV);
SetLength(Edits,EditsCol*MaxV);
SetLength(Labels,LabelsCol*MaxV);
SetLength(Buttons,ButtonsCol*MaxV);
SetLength(CheckBoxs,CheckBoxsCol*MaxV);

//   1 
ItemVilage[0]:=NameVillage;
ItemVilage[0].PageControl:=All_Village;
PCVillage[0]:=Village;
Items[0]:=Ferms;
Items[1]:=CenterVillage;
Items[2]:=form1.Farm;
Edits[0]:=OrderConstruction;
Edits[1]:=Proportional;
Labels[0]:=OrderConstLabel;
Labels[1]:=ProportionLabel;
Labels[2]:=form1.VillageArmyLabel;
Labels[3]:=form1.FarmTaskLabel;
ListVill[0]:=StringGrid1;
ListVill[1]:=StringGrid2;
ListVill[2]:=StringGrid3;
ListVill[3]:=StringGrid4;
ListVill[4]:=form1.VillageArmy;
ListVill[5]:=form1.FarmTask;
Buttons[0]:=StartBuild;
Buttons[1]:=StopBuild;
Buttons[2]:=AddAuto;
Buttons[3]:=form1.Refresh; //
Buttons[4]:=GetArmyB;
Buttons[5]:=AddFarmTask;
Buttons[6]:=DelFarmTask;
Buttons[7]:=SaveFarmTask;
Buttons[8]:=LoadFarmTask;
Buttons[9]:=SendArmy;
Buttons[10]:=StopFarm;
CheckBoxs[0]:=AutoProportion;
CheckBoxs[1]:=form1.SendCom;
CheckBoxs[2]:=form1.SendParal;
CheckBoxs[3]:=form1.FarmPodkrep;
CheckBoxs[4]:=form1.FarmNapadenie;
CheckBoxs[5]:=form1.FarmNabeg;


for i:=0 to MaxV-1 do begin
vil_task[i].time:=now;
vil_task[i].tip:=-1;
vil_task[i].status:='  ';
end;

create_village(MaxV);

for i:=0 to maxv-1 do begin
if Maxv<>1 then switch_village(i,path_dorf1);
try_get_page(path_dorf1,path_login,Response,f);
if f=false then begin log('  dorf1.php');exit end;
// 
akk[i].vil_name:=village_name(Response);
ItemVilage[i].Caption:=akk[vil_id].vil_name;
//   
log('  ...');
 get_res(Response,akk[i].res_village);
 get_ferm(i,Response,akk[i].vil_bilding);
 Delay(300);//
//    
 log('    ...');
 try_get_page(path_dorf2,path_dorf1,Response,f);
 if f=false then begin log('  dorf2.php');exit end;
 get_center(i,Response,akk[i].vil_bilding);
Delay(300);
//   
log('    ...');
try_get_page(server+'build.php?gid=0',path_dorf1,Response,f);
get_list_new_bild(i,Response);
log('   ');
try_get_page(path_send_troop,path_dorf2,Response,f);
get_army(Response,akk[i].vil_army);
show_army(i);
end;//for i
form1.Memo1.Clear;
log('  ');
load_option;
show_ferm;

Buttons[0].Enabled:=true;
form1.ResTimer.Enabled:=true;//. ;
form1.BuildTimer.Enabled:=true;//. 
form1.FarmTimer.Enabled:=true;
form1.BuildTimer.Interval:=1000;
form1.idHTTP1.Disconnect;
end;

procedure load_control;
var ff:textfile; s1,s2:string;
begin
assignfile(ff,'trava_bot.ini');
{$I-}
reset(ff);
{$I+}
if ioresult<>0 then begin
                    log('   ');
                    exit;
                    end;
repeat
readln(ff,s1);
s2:=copy(s1,1,pos('=',s1)-1);
if s2='ServerName' then form1.ServerName.Text:=get_param('"','"',s1);
if s2='UserName' then form1.UserName.Text:=get_param('"','"',s1);
if s2='UserPassword' then form1.UserPassword.Text:=get_param('"','"',s1);
if s2='ProxyUse' then form1.ProxyUse.checked:=StrToBool(get_param('"','"',s1));
if s2='ProxyAdress' then form1.ProxyAdress.Text:=get_param('"','"',s1);
if s2='ProxyPort' then form1.ProxyPort.Text:=get_param('"','"',s1);
if s2='ProxyUser' then form1.ProxyUser.Text:=get_param('"','"',s1);
if s2='ProxyPassword' then form1.ProxyPassword.Text:=get_param('"','"',s1);
if s2='BonusRim' then form1.BonusRim.checked:=StrToBool(get_param('"','"',s1));
until eof(ff);
closefile(ff);
end;

procedure TForm1.FormCreate(Sender: TObject);
var i:integer;
var nid : TNotifyIconData;
s:PAnsiChar;
begin
MaxV:=0;
form1.VillageArmy.Cells[0,0]:=' ';
form1.VillageArmy.Cells[1,0]:='';
form1.VillageArmy.Cells[2,0]:='';

form1.FarmTask.Cells[0,0]:='';
form1.FarmTask.Cells[1,0]:='X';
form1.FarmTask.Cells[2,0]:='Y';
form1.FarmTask.Cells[3,0]:='';
form1.FarmTask.Cells[4,0]:='  ';
form1.FarmTask.Cells[5,0]:='';
form1.UserInfoLabel.Caption:='';
form1.StringGrid5.Cells[0,0]:='';
form1.StringGrid5.Cells[1,0]:='';
form1.StringGrid5.Cells[2,0]:='';
form1.OrderConstruction.Text:='';
load_control;
//    
s:=PAnsiChar(': '+form1.UserName.Text);
Application.CreateHandle;
SetWindowText(Application.Handle,s);
//     
with nid do
begin
cbSize := SizeOf( TNotifyIconData );
Wnd := Form1.Handle;
uID := 1;
uFlags := NIF_ICON or NIF_MESSAGE or NIF_TIP;
uCallbackMessage := WM_USER + 100;
hIcon := Application.Icon.Handle; //   16  16 
szTip :='- v0.5';
end;
Shell_NotifyIcon( NIM_ADD, @nid );

form1.StringGrid3.Cells[0,1]:='';
form1.StringGrid3.Cells[0,2]:='';
form1.StringGrid3.Cells[0,3]:='';
form1.StringGrid3.Cells[0,4]:='';

form1.StringGrid1.Cells[0,0]:='id';
form1.StringGrid1.Cells[1,0]:='';
form1.StringGrid1.Cells[2,0]:=' ';
form1.StringGrid1.Cells[3,0]:=' ';
form1.StringGrid1.Cells[4,0]:='';

form1.StringGrid2.Cells[0,0]:='id';
form1.StringGrid2.Cells[1,0]:='';
form1.StringGrid2.Cells[2,0]:=' ';
form1.StringGrid2.Cells[3,0]:=' ';
form1.StringGrid2.Cells[4,0]:='';

form1.StringGrid4.Cells[0,0]:='id';
form1.StringGrid4.Cells[1,0]:='  ';
form1.StringGrid4.Cells[2,0]:=' ';
form1.StringGrid4.Cells[3,0]:=' ';
form1.StringGrid4.Cells[4,0]:='';

form1.StringGrid3.Cells[1,0]:=' ';
form1.StringGrid3.Cells[2,0]:=' ';
form1.StringGrid3.Cells[3,0]:='';

  for i:=0 to 20 do begin
  buildingCost[0,i,0]:=0;
  buildingCost[0,i,1]:=0;
  buildingCost[0,i,2]:=0;
  buildingCost[0,i,3]:=0;
  end;
  buildingCost[1] := lenyadorCost;
	buildingCost[2] := barroCost;
	buildingCost[3] := hierroCost;
	buildingCost[4] := cerealCost;
	buildingCost[5] := sawmillCost;
	buildingCost[6] := brickyardCost;
	buildingCost[7] := ironFoundryCost;
	buildingCost[8] := flourMillCost;
	buildingCost[9] := bakeryCost;
	buildingCost[10] := warehouseCost;
	buildingCost[11] := granaryCost;
	buildingCost[12] := blacksmithCost;
	buildingCost[13] := armouryCost;
	buildingCost[14] := tournamentSquareCost;
	buildingCost[15] := mainBuildingCost;
	buildingCost[16] := rallyPointCost;
	buildingCost[17] := marketplaceCost;
	buildingCost[18] := embassyCost;
	buildingCost[19] := barracksCost;
	buildingCost[20] := stableCost;
	buildingCost[21] := workshopCost;
	buildingCost[22] := academyCost;
	buildingCost[23] := crannyCost;
	buildingCost[24] := ayuntamientoCost;
	buildingCost[25] := residenceCost;
	buildingCost[26] := palaceCost;
	buildingCost[27] := tesoroCost;
	buildingCost[28] := oficinaComercioCost;
	buildingCost[29] := greatBarrackCost;
	buildingCost[30] := greatStableCost;
	buildingCost[31] := wallRomansCost;
	buildingCost[32] := wallTeutonsCost;
	buildingCost[33] := wallGaulsCost;
	buildingCost[34] := canteroCost;
	buildingCost[35] := cerveceriaCost;
	buildingCost[36] := trampaCost;
	buildingCost[37] := casaHeroeCost;
	buildingCost[38] := greatWarehouseCost;
	buildingCost[39] := greatGranaryCost;
  chudo:=maravillaCost;     //,=40

building_now:=false;
form1.CurTime.Caption:=' :_____ '+DateTimeToStr(now);
form1.Memo1.Clear;
form1.StringGrid4.RowCount:=2;
last_build_id:=0;

end;


procedure TForm1.StringGrid1DblClick(Sender: TObject);
var i:integer;
begin
i:=all_village.ActivePageIndex;
Edits[EditsCol*i].Text:=Edits[EditsCol*i].Text+ListVill[ListVillCol*i].Cells[0,ListVill[ListVillCol*i].Row]+';';
end;

procedure TForm1.StringGrid2DblClick(Sender: TObject);
var i:integer;
begin
i:=all_village.ActivePageIndex;
if ListVill[ListVillCol*i+1].Cells[2,ListVill[ListVillCol*i+1].Row]=' ' then
  begin
  Edits[EditsCol*i].Text:=Edits[EditsCol*i].Text+
  ListVill[ListVillCol*i+1].Cells[0,ListVill[ListVillCol*i+1].Row]+'&'+
  ListVill[ListVillCol*i+3].Cells[1,ListVill[ListVillCol*i+3].Row]+';';
  end
  else
  begin
  Edits[EditsCol*i].Text:=Edits[EditsCol*i].Text+
  ListVill[ListVillCol*i+1].Cells[0,ListVill[ListVillCol*i+1].Row]+';';
  end;
end;

Procedure get_build_time(Response:string;var num:integer;var buf1,buf2:TdateTime;var tip1,tip2:integer);
//num - - 
//buf1 - 1 
//buf2 - 2 
//tip1,tip1 - 0- 1 - 

const qw='<div id="lbau1"><div class="f10 b">';
var s1,s2,nameb:string;i:integer;f:boolean;
begin
if pos(qw,Response)<>0 then  // 
  begin
  delete(Response,1,pos(qw,Response));
  s1:=get_param2('<table','</table>',Response);//    ;
  s2:=get_param2('<tr>','</tr>',s1);// 
  delete(s2,1,pos(s2,'</td>')+5);//   
  nameB:=get_param2('<td>',' ',s2);//   
  //  /
  i:=0;f:=false;
  repeat
  inc(i);
  if pos(nameB,akk[vil_id].vil_bilding[i].name)<>0 then begin
                                                        f:=true;
                                                        end;
  until f or (i=18);
  if f=true then begin tip1:=0;tip2:=1 end // -     
            else begin tip1:=1;tip2:=0 end;// -  
  num:=1;
  buf1:=StrToTime(get_param2('id=timer1>','<',s2));
  delete(s1,1,pos(s1,'</tr>')+5);//    2 
  s2:=get_param2('<tr>','</tr>',s1);//2  ( )
  if s2<>'' then
    begin
    num:=2; //   -  
    buf2:=StrToTime(get_param2('id=timer2>','<',s2));
    end;
  end
  else begin // 
       num:=0;
       buf1:=0;
       buf2:=0;
       tip1:=0;
       tip2:=0;
       end;
end;//function get_build_time

procedure upd_bilding_list(vid,id:integer);//    
var ff:boolean;
begin
                if id<19 then
                begin
                try_get_page(path_dorf1,path_dorf1,Response,ff);
                get_ferm(vid,Response,akk[vid].vil_bilding);
                end
                           else
                begin
                try_get_page(path_dorf2,path_dorf1,Response,ff);
                get_center(vid,Response,akk[vid].vil_bilding);
                end;
end;



procedure auto_proportional(vid:integer;var OrderList:string);
type proportional=array [0..3] of single;

var id,base,i,j,lvl,tip,id_z,id_s:integer;m:single;
prop,prod:proportional;
f:boolean; s,s1:string;
begin
s:=Edits[EditsCol*vid+1].Text;
s1:=copy(s,1,pos('/',s)-1);
prop[0]:=Bild_lvl(s1);

delete(s,1,pos('/',s));
s1:=copy(s,1,pos('/',s)-1);
prop[1]:=Bild_lvl(s1);

delete(s,1,pos('/',s));
s1:=copy(s,1,pos('/',s)-1);
prop[2]:=Bild_lvl(s1);
delete(s,1,pos('/',s));

s1:=s;
prop[3]:=Bild_lvl(s1);

//    -   - .
  m:=prop[0]; base:=0;
  for i:=1 to 3 do if m<prop[i] then begin m:=prop[i]; base:=i end;
  for i:=0 to 3 do prop[i]:=prop[i]/m;
//        
  for i:=0 to 3 do Prod[i]:=akk[vid].res_village[i].per_hour/akk[vid].res_village[base].per_hour;
// 
m:=0; tip:=base+1;
for i:=0 to 3 do begin
if (prop[i]-prod[i])>=m then
                        begin //       
                        m:=prop[i]-prod[i];
                        tip:=i+1;//   1- 2- 3- 4-
                        end;
end;//for i
case tip of
1:log('  : ');
2:log('  : ');
3:log('  : ');
4:log('  : ');
end;
//      
//  
i:=0;f:=false;id:=0;lvl:=0;
repeat
inc(i);
if akk[vid].vil_bilding[i].tip=tip then
    begin
    lvl:=akk[vid].vil_bilding[i].lvl;
    id:=akk[vid].vil_bilding[i].id;
    f:=true;
    end;
until (i=18) or f;
//  
for j:=i to 18 do begin
if akk[vid].vil_bilding[j].tip=tip then
   begin
   if akk[vid].vil_bilding[j].lvl<lvl then
        begin
        lvl:=akk[vid].vil_bilding[j].lvl;
        id:=akk[vid].vil_bilding[j].id;
        end;
   end;
end;//for i
log('    : '+akk[vid].vil_bilding[id].name+' (id='+IntToStr(id)+')');
// ,     
id_s:=0;
for i:=0 to 3 do begin
if (akk[vid].vil_bilding[id].res_req[i]>akk[vid].res_village[i].sklad) then //  
        begin
        if i<3 then begin id_z:=10;log('  ') end //
               else begin id_z:=11;log('  ') end; //
               //           20 
               for j:=19 to 40 do begin
               if (akk[vid].vil_bilding[j].tip=id_z) and
                (akk[vid].vil_bilding[j].lvl<20) then id_s:=akk[vid].vil_bilding[j].id;
               end;
        end;
end; //for i
if id_s<>0 then begin id:=id_s;log('  : '+akk[vid].vil_bilding[id].name+' (id='+IntToStr(id)+')') end;
OrderList:=IntToStr(id)+';';
end;//_

procedure Build_Zdanie(village_id:integer; var order:string; var err:integer;var time_wait:Tdatetime;var id_z:integer;var num:integer);
//err=0  
//err=1   
//err=2  
//err=3      
//err=4  
//err=5    - =auto
//err=6  
//err=7    
var i,id,tip1,tip2:integer;
s1,s2,ids,idsc,name_b:string;
buf1,buf2:tdatetime;
ff,fbb:boolean;
time_wnb:TdateTime;
begin
form1.ResTimer.Enabled:=false;

// 
ids:=Order; name_b:='';
if pos(';',ids)<>0 then
  begin
  idsc:=copy(ids,1,pos(';',ids)-1);
  if idsc='auto' then begin
                      err:=5;//  
                      delete(ids,1,pos(';',ids));
                      Order:=ids;
                      exit;
                      end;
  if pos('&',idsc)<>0 then
  begin
  name_b:=copy(idsc,pos('&',idsc)+1,Length(idsc)-pos('&',idsc));
  idsc:=copy(idsc,1,pos('&',idsc)-1);
  end;
  if tryStrToInt(idsc,id) then id:=strtoInt(idsc)
                          else begin
                               //   
                               err:=7;
                               exit;
                               end;
  if (id<0) or (id>40) then begin
                               //   
                               err:=7;
                               exit;
                               end;


//   
  try_get_page(path_build+IntToStr(id),path_dorf1,Response,ff);
  if id<19 then s1:=get_param2('dorf1.php?','">',Response)//  
           else begin if name_b='' then s1:=get_param2('dorf2.php?','">',Response)
                                   else begin
                                        if pos(name_b,response)<>0 then
                                             begin
                                             delete(Response,1,pos(name_b,response));
                                             delete(Response,pos('<h2>',response),length(Response)-pos('<h2>',response));
                                             s1:=get_param2('dorf2.php?','">',Response);
                                             ff:=false;
                                             get_res_by_id(village_id,0,Response,res_req,res_need,time_wnb);
                                             end
                                             else begin //     
                                                  s1:='';
                                                  //     :'+name_b);
                                                  err:=3;
                                                  //   
                                                  delete(ids,1,pos(';',ids));
                                                  name_b:='';
                                                  Order:=ids;
                                                  end;
                                        end;
               end;
  //
  fbb:=false;
  if s1<>'' then begin //
                   //log(' : '+akk[vil_id].vil_bilding[id].name+'  (id='+IntToStr(id)+')');
                   if id<19 then try_get_page(path_dorf1+'?'+s1,path_build+IntToStr(id),Response,ff)
                            else try_get_page(path_dorf2+'?'+s1,path_build+IntToStr(id),Response,ff);
                   // 
                   err:=0;
                   //   
                   delete(ids,1,pos(';',ids));
                   Order:=ids;
                   fbb:=true;
                   //   
                   try_get_page(path_dorf1,path_build+IntToStr(id),Response,ff);
                   get_res(Response,akk[village_id].res_village);
                   //    
                   upd_bilding_list(village_id,id);
                   akk[village_id].vil_bilding[id].name:='>>> '+akk[village_id].vil_bilding[id].name;
                   //     
                   if id<19 then s2:=path_dorf1 else s2:=path_dorf2;//Referer
                   try_get_page(path_build+IntToStr(id),s2,Response,ff);
                   get_res_by_id(village_id,id,Response,
                                 akk[village_id].vil_bilding[id].res_req,
                                 akk[village_id].vil_bilding[id].res_need,
                                 akk[village_id].vil_bilding[id].res_time);
                   //   
                   try_get_page(server+'build.php?gid=0',path_dorf1,Response,ff);
                   get_list_new_bild(village_id,Response);
                   // 
                   for i:=1 to 40 do begin
                   Application.ProcessMessages;
                   calc_res_need(vil_id,akk[vil_id].vil_bilding[i].res_req,akk[vil_id].vil_bilding[i].res_need,akk[vil_id].vil_bilding[i].res_time);
                   end
                 end; //then -   

  //  ,  ( )
  try_get_page(path_dorf1,path_build+IntToStr(id),Response,ff);
  get_build_time(Response,num,buf1,buf2,tip1,tip2);
  case num of
  0: //  
              begin
                if name_b=''then //name_b=''      
                   begin
                   //    -  
                     err:=1;
                     if akk[vil_id].vil_bilding[id].res_req[0]<>0
                          then buf1:=akk[vil_id].vil_bilding[id].res_time // 
                          else buf1:=StrToTime('0:00:10');//  -      

                   end
                   else
                   begin
                   //   
                   err:=1;
                   buf1:=time_wnb; // 
                   end;
              time_wait:=buf1;
              end;//  
   1:  begin //  - 1 
       if (id<19) and (tip1=0) then err:=2;
       if (id<19) and (tip1=1) then err:=1;
       if (id>18) and (tip1=1) then err:=2;
       if (id>18) and (tip1=0) then err:=1;

       time_wait:=buf1;
       end;
   2:  begin//  - 2 
       err:=2;
       if buf1<buf2 then time_wait:=buf1
                    else time_wait:=buf2;
       end;
   end;//case
  id_z:=id;
  if fbb then err:=0;
  //form1.BuildTimer.Interval:=round(buf2*24*60*60*1000)+10000+Random(50000);
  //form1.BuildTimer.Enabled:=true;
  //log('   : '+TimeToStr(buf2));
  //form1.Build_mes.Caption:='  : '+DateTimeToStr(now+buf2+StrToTime('0:01:00'));
  end
  else
  begin  // ,  
  err:=4;
  end;
show_ferm;
form1.ResTimer.Enabled:=true;
end;// 

procedure TForm1.ResTimerTimer(Sender: TObject);
var i,j:integer;var s2:Tdatetime;
res,need:array [0..3] of integer;ff:boolean;
begin
form1.ResTimer.Enabled:=false;
for j:=0 to MaxV-1 do begin
for i:=0 to 3 do begin
akk[j].res_village[i].v_nalichee:=trunc((now-last_update_res)*24*akk[j].res_village[i].per_hour)+akk[j].res_village[i].for_timer;
if akk[j].res_village[i].v_nalichee>akk[j].res_village[i].sklad then akk[j].res_village[i].v_nalichee:=akk[j].res_village[i].sklad;
Application.ProcessMessages;
end;//for i
end;//for j
show_res;
for j:=0 to MaxV-1 do begin
for i:=1 to 40 do begin
Application.ProcessMessages;
calc_res_need(j,akk[j].vil_bilding[i].res_req,akk[j].vil_bilding[i].res_need,akk[j].vil_bilding[i].res_time);
end;end;
// 
for j:=0 to MaxV-1 do begin
if ListVill[ListVillCol*j+3].RowCount>1 then
begin
 for i:=1 to ListVill[ListVillCol*j+3].RowCount do begin
 res_convert(ListVill[ListVillCol*j+3].Cells[2,i],res,ff);
 calc_res_need(j,res,need,s2);
 ListVill[ListVillCol*j+3].Cells[3,i]:=str_res(need);
 ListVill[ListVillCol*j+3].Cells[4,i]:=TimeToStr(s2);
 end;
end;//for i
end;//for j
show_ferm;
form1.ResTimer.Enabled:=true;
end;




procedure TForm1.SaveControlClick(Sender: TObject);
var ff:textfile;
begin
assignfile(ff,'trava_bot.ini');
{$I-}
rewrite(ff);
{$I+}
if ioresult<>0 then begin
                    log('  ,   ');
                    exit;
                    end;
writeln(ff,form1.ServerName.name+'="'+form1.ServerName.Text+'"');
writeln(ff,form1.UserName.name+'="'+form1.UserName.Text+'"');
writeln(ff,form1.UserPassword.name+'="'+form1.UserPassword.Text+'"');
writeln(ff,form1.ProxyUse.name+'="'+BoolToStr(form1.ProxyUse.checked,true)+'"');
writeln(ff,form1.ProxyAdress.name+'="'+form1.ProxyAdress.Text+'"');
writeln(ff,form1.ProxyPort.name+'="'+form1.ProxyPort.Text+'"');
writeln(ff,form1.ProxyUser.name+'="'+form1.ProxyUser.text+'"');
writeln(ff,form1.ProxyPassword.name+'="'+form1.ProxyPassword.text+'"');
writeln(ff,form1.BonusRim.name+'="'+BoolToStr(form1.BonusRim.checked,true)+'"');
closefile(ff);
save_option;
end;//save_control;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var nid : TNotifyIconData;ch2:char;
begin
//         J
with nid do
begin
cbSize := SizeOf( TNotifyIconData );
Wnd := Form1.Handle;
uID := 1;
uFlags := NIF_ICON or NIF_MESSAGE or NIF_TIP;
uCallbackMessage := WM_USER + 100;
hIcon := Application.Icon.Handle; //   16  16 
szTip := '- v0.5';
end;
Shell_NotifyIcon( NIM_DELETE, @nid );

form1.SaveControlClick(self);
if DirectoryExists('log')=false then CreateDir('log');
ch2:=TimeSeparator;
TimeSeparator:='-';
form1.Memo1.Lines.SaveToFile('log/'+DateTimeToStr(now)+'.txt');
TimeSeparator:=ch2;
end;

procedure TForm1.CloseToTrayClick(Sender: TObject);
begin
Application.Minimize;
Application.CreateHandle;
ShowWindow(Application.Handle, SW_HIDE);
Application.ShowMainForm := FALSE;
end;

procedure createAtack(vid:integer;Task:string;var data:TStringList);
var i:integer; s1,s2:string;
begin
data.Clear;
for i:=0 to 10 do begin
s1:='t'+IntToStr(i+1)+'=';
if pos(s1,task)=0 then data.Add(s1)
                  else begin
                       s2:=get_param(s1,'&',Task);
                       if s2<>'all' then data.Add(s1+s2)
                                    else data.Add(s1+IntToStr(akk[vid].vil_army[i].num));
                       end;
end;//for i
s1:=get_param('c=','&',Task);
data.Add('c='+s1);

end;//procedure createAtack


procedure sendTroopsXY(vid,x,y:integer;zad:string);
var
data:TStringList;
ff:boolean;
s1,s2,resp:string;
i:integer;
begin
data:=TstringList.Create;

if MaxV>1 then switch_village(vid,path_dorf1);

try_get_page(path_send_troop,path_dorf2,resp,ff);
if ff= false then begin log('    '); exit end;
if pos('name="login" value=',response)<>0 then
  begin
  log('  , ...');
   Login_trava(ff);
   if ff=false then begin
                    log('   ');
                    Data.Free;
                    exit;
                    end;
  try_get_page(path_send_troop,path_dorf2,resp,ff);
  end;

get_army(resp,akk[vid].vil_army);
show_army(vid);
createAtack(vid,zad,data);
data.Add(get_param2('input type="hidden" name="','"',resp)+'='+get_param2('value="','"',resp));
data.Add('x='+IntTOStr(x));
data.Add('y='+IntTOStr(y));
data.Add('dname=');
data.Add('s1.x=38');
data.Add('s1.y=5');
delay(300);

try_post_page(path_send_troop,path_send_troop,data,resp,ff);
if ff=false then begin
                 log('no connection...');
                 exit;
                 end;
data.Clear;
delay(500);
//
for i:=1 to 15 do begin
s1:=get_param2('input type="hidden" name="','"',resp);
s2:=get_param2('value="','"',resp);
//if s2<>'0' then s1:=s1+'='+s2 else s1:=s1+'=';
s1:=s1+'='+s2;
data.Add(s1);
end;//for i
data.Add('s1.x=38');
data.Add('s1.y=10');
try_post_page(path_send_troop,path_send_troop,data,resp,ff);
delay(150);
//try_get_page(server+'build.php?gid=16',path_send_troop,resp,ff);
Data.Free;
end;



procedure TForm1.AddAutoClick(Sender: TObject);
var i:integer;
begin
i:=All_Village.ActivePageIndex;
Edits[EditsCol*i].Text:=Edits[EditsCol*i].Text+'auto;';
end;

//   


procedure start_task(vid:integer);
begin
if CheckBoxs[CheckBoxsCol*vid].Checked then
   begin
   vil_task[vid].time:=now;
   vil_task[vid].tip:=1;
   vil_task[vid].status:='  .';
   end
   else
   begin
   vil_task[vid].time:=now;
   vil_task[vid].tip:=0;
   vil_task[vid].status:='   .';
   end;
end;

procedure Stop_task(vid:integer);
begin
   vil_task[vid].time:=now;
   vil_task[vid].tip:=-1;
   vil_task[vid].status:=' .';
end;

procedure TForm1.StopBuildClick(Sender: TObject);
var i:integer;
begin
  i:=All_Village.ActivePageIndex;
  Buttons[ButtonsCol*i].Enabled:=true;
  Buttons[ButtonsCol*i+1].Enabled:=false;
  log('    '+akk[i].vil_name);
  Stop_task(i);
end;

procedure TForm1.StartBuildClick(Sender: TObject);
var i:integer;


begin
  i:=All_Village.ActivePageIndex;
  Buttons[ButtonsCol*i].Enabled:=false;
  Buttons[ButtonsCol*i+1].Enabled:=true;
  log('   : '+akk[i].vil_name);
  Start_task(i);
end;


procedure TForm1.HandWorkClick(Sender: TObject);
var i:integer;
begin
i:=All_Village.ActivePageIndex;
edits[editscol*i+1].Enabled:=false;
end;

procedure TForm1.AutoWorkProportionalClick(Sender: TObject);
var i:integer;
begin
i:=All_Village.ActivePageIndex;
Edits[EditsCol*i+1].Enabled:=true;
end;

procedure refresh_village(village_id:integer);
var i:integer;ff:boolean;
begin
 //  
 try_get_page(path_dorf1,path_dorf2,Response,ff);
 if pos('name="login" value="',response)<>0 then
  begin
  log('  , ...');
  Login_trava(ff);
   if ff=false then begin
                    log('  !!!');
                    exit;
                    end;
  end;

if MaxV>1 then switch_village(village_id,path_dorf1);
  //   
  try_get_page(path_dorf1,path_dorf2,Response,ff);
  get_res(Response,akk[village_id].res_village);
        // 
        for i:=1 to 40 do begin
        Application.ProcessMessages;
        calc_res_need(village_id,
                      akk[village_id].vil_bilding[i].res_req,
                      akk[village_id].vil_bilding[i].res_need,
                      akk[village_id].vil_bilding[i].res_time);
        end;
  get_ferm(village_id,Response,akk[village_id].vil_bilding);
  try_get_page(path_dorf2,path_dorf1,Response,ff);
  get_center(village_id,Response,akk[village_id].vil_bilding);
  try_get_page(server+'build.php?gid=0',path_dorf1,Response,ff);
  get_list_new_bild(vil_id,Response);
end;

procedure NewOrder(id:integer;var Order:string);
var k,idnew:integer;s1,s2,s3:string; f:boolean;
begin

k:=Length(Order);
if k=0 then exit
       else if Order[k]<>';' then Order:=Order+';' ; //   -  ;   !!!
s1:=Order;
f:=false;
repeat
k:=pos(';',s1);
s2:=copy(s1,1,k-1);
s3:=copy(s1,1,k);
Delete(s1,1,k);
if pos('&',s2)<> 0 then begin
                        s2:=copy(s2,1,pos('&',s2)-1);
                        end;
if s2<>'' then idnew:=StrToInt(s2);
if id<19 then if idnew>18 then begin
                               f:=true;
                               s2:=s1;// 
                               s1:=Order;
                               Delete(s1,pos(s3,s1),length(s1)-pos(s3,s1)+1);// 
                               s1:=s3+s1+s2;
                               end;
if id>18 then if idnew<19 then begin
                               f:=true;
                               s2:=s1;// 
                               s1:=Order;
                               Delete(s1,pos(s3,s1),length(s1)-pos(s3,s1)+1);// 
                               s1:=s3+s1+s2;
                               end;

until (s1='') or f;
if s1<>'' then Order:=s1;
end;
//  ,  
procedure TForm1.BuildTimerTimer(Sender: TObject);
var i,id_z,id_z2,num_s:integer;
err,err2:integer; NewOrd:string;
waittime,waittime2:TdateTime;
Order:string;
    procedure err_work(err,id_z:integer;waittime:TdateTime);
      begin
             case err of
           0:begin
             Edits[EditsCol*i].Text:=Order;
             log(': '+akk[i].vil_name+'.  : '+akk[vil_id].vil_bilding[id_z].name+'  (id='+IntToStr(id_z)+')');
             waittime:=waittime+RandTime(waitB);
             vil_task[i].time:=now+waittime;
             vil_task[i].status:='  ';
             log(' : '+DateTimeToStr(vil_task[i].time));
             end;
           1:begin
             //Edits[EditsCol*i].Text:=Order;
             log(': '+akk[i].vil_name+'.    : '+akk[vil_id].vil_bilding[id_z].name+'  (id='+IntToStr(id_z)+')');
             waittime:=waittime+RandTime(waitB);
             vil_task[i].time:=now+waittime;
             vil_task[i].status:=' , .';
             log(' : '+DateTimeToStr(vil_task[i].time));
             end;
           2:begin
             //Edits[EditsCol*i].Text:=Order;
             log(': '+akk[i].vil_name+'.       .');
             waittime:=waittime+RandTime(waitB);
             vil_task[i].time:=now+waittime;
             log(' : '+DateTimeToStr(vil_task[i].time));
             vil_task[i].status:=' ( )';
             end;
           3:begin
             Edits[EditsCol*i].Text:=Order;
             log(': '+akk[i].vil_name+'.      .');
             vil_task[i].time:=now+waittime;// waittime  10 
             vil_task[i].status:='  ';
             log(' : '+DateTimeToStr(vil_task[i].time));

             end;
           4:begin
             //Edits[EditsCol*i].Text:=Order;
             log(': '+akk[i].vil_name+'.  ');
             vil_task[i].time:=now;
             vil_task[i].tip:=-1;
             Buttons[ButtonsCol*i].Enabled:=true;
             Buttons[ButtonsCol*i+1].Enabled:=false;
             vil_task[i].status:='';
             end;
           5:begin
             Edits[EditsCol*i].Text:=Order;
             CheckBoxs[CheckBoxsCol*i].Checked:=true;
             log(': '+akk[i].vil_name+'.    ');
             vil_task[i].time:=now+RandTime(waitB);
             vil_task[i].tip:=1;
             log(' : '+DateTimeToStr(vil_task[i].time));
             vil_task[i].status:='  .';
             end;
           6:begin
             log('     ,    5 ');
             vil_task[i].time:=now+StrToTime('0:05:00');
             vil_task[i].status:=' ';
             end;
           7:begin
             log(': '+akk[i].vil_name+'.    ,  .');
             vil_task[i].time:=now;
             vil_task[i].tip:=-1;
             Buttons[ButtonsCol*i].Enabled:=true;
             Buttons[ButtonsCol*i+1].Enabled:=false;
             vil_task[i].status:='  ';
             end;
          end;//case

      end;
begin
form1.CurTime.Caption:=' : '+DateTimeToStr(now);
form1.StringGrid5.RowCount:=MaxV+1;
form1.BuildTimer.Enabled:=false;
// 
for i:=0 to maxV-1 do
  begin
  if vil_task[i].tip>-1 then
    if vil_task[i].time<now then
       begin // 
         refresh_village(i);
         if vil_task[i].tip=0 then Order:=Edits[EditsCol*i].Text;
         if vil_task[i].tip=1 then begin auto_proportional(i,Order);Edits[EditsCol*i].Text:=Order end;
         err:=0;waittime:=0;id_z:=0;
         //
         form1.BuildTimer.Enabled:=false;
         Build_Zdanie(i,Order,err,waittime,id_z,num_s);
         form1.BuildTimer.Enabled:=true;
         err_work(err,id_z,waittime);
         if (vil_task[i].tip=0) and (form1.BonusRim.Checked=true) then
         begin
           refresh_village(i);
           NewOrder(id_z,Order);
           form1.BuildTimer.Enabled:=false;
           Build_Zdanie(i,Order,err2,waittime2,id_z2,num_s);
           form1.BuildTimer.Enabled:=true;
           if waittime>waittime2 then waittime:=waittime2;
           err_work(err2,id_z2,waittime);
         end;
          // 

       end
       else begin
            //vil_task[i].status:='  ';
            end;
  form1.StringGrid5.Cells[0,i+1]:=akk[i].vil_name;
  form1.StringGrid5.Cells[1,i+1]:=TimeToStr(vil_task[i].time);
  form1.StringGrid5.Cells[2,i+1]:=vil_task[i].status;
  end;//for i   
// 
form1.BuildTimer.Enabled:=true;
end;

procedure TForm1.RefreshClick(Sender: TObject);
var village_id:integer;
begin
village_id:=All_Village.ActivePageIndex;
refresh_village(village_id);
end;

procedure TForm1.AutoProportionClick(Sender: TObject);
var i:integer;
begin
i:=All_Village.ActivePageIndex;
if CheckBoxs[CheckBoxsCol*i].Checked=true
      then Edits[EditsCol*i+1].Enabled:=true
      else Edits[EditsCol*i+1].Enabled:=false;
end;

procedure TForm1.Button3Click(Sender: TObject);
var s1:string;f:boolean;
begin
try_get_page(path_profile,path_dorf1,s1,f);
 if pos('name="login" value="',response)<>0 then
  begin
  log('  , ...');
  Login_trava(f);
   if f=false then begin
                    log(' ');// 
                    end;
  try_get_page(path_profile,path_dorf1,s1,f);
  end;

get_user_info(s1,user_info);show_user_info;
end;

procedure TForm1.GetArmyBClick(Sender: TObject);
var resp:string;ff:boolean;i,vid:integer;
begin
vid:=All_Village.ActivePageIndex;
if MaxV>1 then switch_village(vid,resp);
try_get_page(path_send_troop,path_dorf2,resp,ff);
if ff=false then begin
                 log('no connection...');
                 exit;
                 end;
if pos('name="login" value=',resp)<>0 then
  begin
  log('  , ...');
  Login_trava(ff);
  if ff=false then  begin
                    log('   ,    5 ');
                    exit;
                    end;
  try_get_page(path_send_troop,path_dorf2,resp,ff);
  end;
get_army(resp,akk[vid].vil_army);
show_army(vid);

end;



procedure TForm1.FarmNabegClick(Sender: TObject);
var vid:integer;
begin
vid:=All_Village.ActivePageIndex;
if CheckBoxs[CheckBoxsCol*vid+5].Focused then
begin
CheckBoxs[CheckBoxsCol*vid+3].Checked:=false;
CheckBoxs[CheckBoxsCol*vid+4].Checked:=false;
CheckBoxs[CheckBoxsCol*vid+5].Checked:=true;
end;
end;

procedure TForm1.FarmNapadenieClick(Sender: TObject);
var vid:integer;
begin
vid:=All_Village.ActivePageIndex;
if CheckBoxs[CheckBoxsCol*vid+4].Focused then
begin
CheckBoxs[CheckBoxsCol*vid+3].Checked:=false;
CheckBoxs[CheckBoxsCol*vid+4].Checked:=true;
CheckBoxs[CheckBoxsCol*vid+5].Checked:=false;
end;
end;

procedure TForm1.FarmPodkrepClick(Sender: TObject);
var vid:integer;
begin
vid:=All_Village.ActivePageIndex;
if CheckBoxs[CheckBoxsCol*vid+3].Focused then
begin
CheckBoxs[CheckBoxsCol*vid+3].Checked:=true;
CheckBoxs[CheckBoxsCol*vid+4].Checked:=false;
CheckBoxs[CheckBoxsCol*vid+5].Checked:=false;
end;

end;


//  ,  
procedure TForm1.AddFarmTaskClick(Sender: TObject);
var vid,i:integer;
resp,s1,s2,taskStr:string;
ff:boolean;
data:TStringList;
begin
  vid:=All_Village.ActivePageIndex;
  for i:=1 to 11 do begin
  s2:=ListVill[ListVillCol*vid+4].Cells[2,i];
  if s2<>'' then
              begin
              if (s2<>'0')  then
                              begin
                              s1:=s1+'t'+IntToStr(i)+'='+s2+'&';
                              end
              end

  end;//for i
if s1='' then begin log('  ');Data.Free;exit end;

  if CheckBoxs[CheckBoxsCol*vid+3].Checked then begin s1:=s1+'c=2&' end;
  if CheckBoxs[CheckBoxsCol*vid+4].Checked then begin s1:=s1+'c=3&' end;
  if CheckBoxs[CheckBoxsCol*vid+5].Checked then begin s1:=s1+'c=4&' end;
taskStr:=s1;
data:=TstringList.Create;
createAtack(0,taskStr,data);
//

if MaxV>1 then switch_village(vid,resp);

try_get_page(path_send_troop,path_dorf2,resp,ff);
if ff= false then begin log('    '); exit end;
if pos('name="login" value=',response)<>0 then
  begin
  log('  , ...');
   Login_trava(ff);
   if ff=false then begin
                    log('   ');
                    Data.Free;
                    exit;
                    end;
  try_get_page(path_send_troop,path_dorf2,resp,ff);
  end;
data.Add(get_param2('input type="hidden" name="','"',resp)+'='+get_param2('value="','"',resp));
i:=ListVill[ListVillCol*vid+5].Row;
s1:=ListVill[ListVillCol*vid+5].Cells[1,i];//X
s2:=ListVill[ListVillCol*vid+5].Cells[2,i];//Y
if (s1<>'') and (s2<>'') then begin
                              data.Add('x='+s1);
                              data.Add('y='+s2);
                              data.Add('dname=');
                              end
                         else begin
                              s1:=ListVill[ListVillCol*vid+5].Cells[0,i];// 
                              data.Add('x=');
                              data.Add('y=');
                              data.Add('dname='+AnsiToUTF8(s1));
                              end;
data.Add('s1.x=38');
data.Add('s1.y=5');
delay(500);
try_post_page(path_send_troop,path_send_troop,data,resp,ff);
if ff=false then begin log('     ');data.Free; exit end;
if pos('<div class="f10 e b">',resp)<>0 then begin
                                             log('  ');
                                             data.Free;
                                             exit;
                                             end;

delete(resp,1,pos('form method="POST"',resp));
s1:=get_param2('<a href','/a>',resp);
s2:=get_param2('>','<',s1);
ListVill[ListVillCol*vid+5].Cells[0,i]:=s2;
s1:=get_param2('<a href','/a>',resp);
s2:=get_param2('>','<',resp);
ListVill[ListVillCol*vid+5].Cells[3,i]:=s2;
delete(resp,1,pos('<tr class="cbg1">',resp));
delete(resp,1,pos('<tr class="cbg1">',resp));
s1:=get_param2('<td width','/td>',resp);
s2:=get_param2('>','<',s1);
ListVill[ListVillCol*vid+5].Cells[4,i]:=s2;
ListVill[ListVillCol*vid+5].Cells[5,i]:=TaskStr;
if i=ListVill[ListVillCol*vid+5].RowCount-1 then ListVill[ListVillCol*vid+5].RowCount:=ListVill[ListVillCol*vid+5].RowCount+1;
data.Free;
end;//  ,  

procedure TForm1.VillageArmyDblClick(Sender: TObject);
var vid:integer;
begin
vid:=All_Village.ActivePageIndex;
ListVill[ListVillCol*vid+4].Cells[2,ListVill[ListVillCol*vid+4].Row]:=ListVill[ListVillCol*vid+4].Cells[1,ListVill[ListVillCol*vid+4].Row];
end;

procedure TForm1.DelFarmTaskClick(Sender: TObject);
var
  vid,i,RowToDelete: Integer;
begin
  vid:=All_Village.ActivePageIndex;
  RowToDelete:=ListVill[ListVillCol*vid+5].Row;
  with ListVill[ListVillCol*vid+5] do
  begin
    if (RowToDelete >= 1) and (RowToDelete < RowCount-1) then
    begin
      for i := RowToDelete to RowCount - 2 do
        Rows[i].Assign(Rows[i + 1]);
      RowCount := RowCount - 1;
    end;
  end;
end;



procedure TForm1.SendComClick(Sender: TObject);
var vid:integer;
begin
vid:=All_Village.ActivePageIndex;
if CheckBoxs[CheckBoxsCol*vid+1].Focused then
 begin
 CheckBoxs[CheckBoxsCol*vid+1].Checked:=true;
 CheckBoxs[CheckBoxsCol*vid+2].Checked:=false;
 end;
end;

procedure TForm1.SendParalClick(Sender: TObject);
var vid:integer;
begin
vid:=All_Village.ActivePageIndex;
if CheckBoxs[CheckBoxsCol*vid+2].Focused then
 begin
 CheckBoxs[CheckBoxsCol*vid+1].Checked:=false;
 CheckBoxs[CheckBoxsCol*vid+2].Checked:=true;
 end;
end;

procedure TForm1.SendArmyClick(Sender: TObject);
var i,j,vid:integer;
begin
vid:=All_Village.ActivePageIndex;
i:=ListVill[ListVillCol*vid+5].RowCount;
if i<=2 then begin
             log('   ');
             exit;
             end;
i:=i-2;//-   
 // :   
 if CheckBoxs[CheckBoxsCol*vid+1].Checked then
 begin
 SetLength(vil_farm,FTC+1);
  FTC:=FTC+1;
  vil_farm[FTC-1].vid:=vid;
  vil_farm[FTC-1].time:=now;
  vil_farm[FTC-1].tip:=0;//
  vil_farm[FTC-1].stat:=0;// 
  vil_farm[FTC-1].line:=1;// -   
  vil_farm[FTC-1].col:=i;//  
 end;
 // :   
 if CheckBoxs[CheckBoxsCol*vid+2].Checked then
 begin
  SetLength(vil_farm,FTC+i);
    for j:=1 to i do begin
    FTC:=FTC+1;
    vil_farm[FTC-1].vid:=vid;
    vil_farm[FTC-1].time:=now;
    vil_farm[FTC-1].tip:=1;//
    vil_farm[FTC-1].stat:=0;// 
    vil_farm[FTC-1].line:=j;//   
    vil_farm[FTC-1].col:=i;//  
    end;//for j
 end;
end;//   

procedure getFarmParametr(vid,l:integer;var x,y:integer;var timeW:TDateTime;var zad,name:string);
begin
 name:=ListVill[ListVillCol*vid+5].Cells[0,l];
 x:=StrToInt(ListVill[ListVillCol*vid+5].Cells[1,l]);
 y:=StrToInt(ListVill[ListVillCol*vid+5].Cells[2,l]);
 timeW:=Stime(ListVill[ListVillCol*vid+5].Cells[4,l]);
 zad:=ListVill[ListVillCol*vid+5].Cells[5,l];

end;

procedure TForm1.FarmTimerTimer(Sender: TObject);
var vid,i,x,y,l:integer; timeW:TDatetime;
zad,nameT:string;
begin
form1.StringGrid6.RowCount:=FTC+2;
              if FTC=0 then begin
              form1.StringGrid6.Rows[1].Clear;
              exit;//   
              end;
form1.FarmTimer.Enabled:=false;
// 
for i:=0 to FTC-1 do begin
 if vil_farm[i].time<now then
  begin
     vid:=vil_farm[i].vid;
     l:=vil_farm[i].line;
     getFarmParametr(vid,l,x,y,timeW,zad,nameT);
     vil_farm[i].name:=nameT;
  case vil_farm[i].stat of
  0: begin // 
     log('   :'+akk[vid].vil_name+
         '  (x,y):'+IntToStr(x)+','+IntToStr(y)+
         ' :'+zad+'   :'+TimeToStr(timeW));
     //     
     form1.BuildTimer.Enabled:=false;
     sendTroopsXY(vid,x,y,zad);
     form1.BuildTimer.Enabled:=true;
     // ......
     vil_farm[i].time:=now+timeW;
     vil_farm[i].stat:=1;// 
     end;
  1: begin // 
     //     
     log('  :'+akk[vid].vil_name+
         '   (x,y):'+IntToStr(x)+','+IntToStr(y)+
         ' :'+zad+'  :'+TimeToStr(timeW));
     vil_farm[i].time:=now+timeW;
     vil_farm[i].stat:=2;//  
     end;
   2: begin // 
       if vil_farm[i].tip=0 then // -    
        begin
        vil_farm[i].line:=vil_farm[i].line+1;
        if vil_farm[i].line>vil_farm[i].col then vil_farm[i].line:=1;
        vil_farm[i].stat:=0;//   
        vil_farm[i].time:=now+RandTime(20);
        log('  :'+akk[vid].vil_name+
         '  (x,y):'+IntToStr(x)+','+IntToStr(y)+
         ' :'+zad+'       .');
          if Buttons[ButtonsCol*vid].Enabled=false then //  
          begin
          Buttons[ButtonsCol*vid+1].Click;// 
          delay(500);
          Buttons[ButtonsCol*vid].Click;// 
          end;
        end;

      if vil_farm[i].tip=1 then // -  
        begin
        vil_farm[i].time:=now+RandTime(20);
        vil_farm[i].stat:=0;//   
        log('  :'+akk[vid].vil_name+
         '  (x,y):'+IntToStr(x)+','+IntToStr(y)+
         ' :'+zad+'       .');
          if Buttons[ButtonsCol*vid].Enabled=false then //  
          begin
          Buttons[ButtonsCol*vid+1].Click;// 
          delay(500);
          Buttons[ButtonsCol*vid].Click;// 
          end;
        end;

      end;
  end;//case vil_farm[i].stat of
form1.StringGrid6.Cells[0,i+1]:=akk[vid].vil_name;
form1.StringGrid6.Cells[2,i+1]:=vil_farm[i].name;
form1.StringGrid6.Cells[1,i+1]:=timeToStr(vil_farm[i].time);
case vil_farm[i].stat of
0:form1.StringGrid6.Cells[3,i+1]:=' ';
1:form1.StringGrid6.Cells[3,i+1]:='  ';
2:form1.StringGrid6.Cells[3,i+1]:=' ';
end;//case vil_farm[i].stat of
end;//if vil_farm[i].time<now then
end;//for i
form1.StringGrid6.Refresh;
form1.FarmTimer.Enabled:=true;
end;//-

procedure TForm1.StopFarmClick(Sender: TObject);
var vid,i:integer;
buf:TFarmTask;
begin
if FTC=0 then exit;
vid:=All_Village.ActivePageIndex;
form1.FarmTimer.Enabled:=false;
i:=FTC;
repeat
DEC(i);
if vil_farm[i].vid=vid then
  begin
  buf:=vil_farm[i];
  vil_farm[i]:=vil_farm[FTC-1];
  vil_farm[FTC-1]:=buf;
  FTC:=FTC-1;
  SetLength(vil_farm,FTC);
  end;
until i=0;
form1.FarmTimer.Enabled:=true;
end;

procedure TForm1.SaveFarmTaskClick(Sender: TObject);
var i,vid:integer;fname:string;
begin
if DirectoryExists('farm')=false then CreateDir('farm');
vid:=All_Village.ActivePageIndex;
for i:=1 to ListVill[ListVillCol*vid+5].RowCount-2 do begin
fname:='farm/'+akk[vid].vil_name+IntToStr(i)+'.txt';
ListVill[ListVillCol*vid+5].Rows[i].SaveToFile(fname);
end;
end;

procedure TForm1.LoadFarmTaskClick(Sender: TObject);
var i,vid:integer;fname:string;
begin
vid:=All_Village.ActivePageIndex;
ListVill[ListVillCol*vid+5].RowCount:=2;
i:=1;
repeat;
fname:='farm/'+akk[vid].vil_name+IntToStr(i)+'.txt';
if FileExists(fname) then
              begin
              ListVill[ListVillCol*vid+5].Rows[ListVill[ListVillCol*vid+5].RowCount-1].LoadFromFile(fname);
              ListVill[ListVillCol*vid+5].RowCount:=ListVill[ListVillCol*vid+5].RowCount+1;
              end;
inc(i)
until FileExists(fname)=false;
end;


end.
